package com.lordjoe.formgenerator;

import java.util.*;

/**
 * com.lordjoe.formgenerator.FormObject
 *
 * @author Steve Lewis
 * @date Jan 29, 2010
 */
public abstract class AbstractFormGroup extends FormObject
{
    public static AbstractFormGroup[] EMPTY_ARRAY = {};
    public static Class THIS_CLASS = AbstractFormGroup.class;

    
    private final List<FormObject> m_Properties = new ArrayList<FormObject>();
    private String m_Title;
    protected AbstractFormGroup(FormObject pParent)
    {
        super(pParent);
    }

    public String getTitle()
    {
        return m_Title;
    }

    public void setTitle(String pTitle)
    {
        m_Title = pTitle;
    }

    @Override
    protected void accumulateTranslations(Set<String> ids) {
         super.accumulateTranslations(ids);
        for(FormObject prop : getProperties())
               prop.accumulateTranslations(ids);
     }
    

    public void addProperty(FormObject added) {
          m_Properties.add(added);
     }
     public FormObject[] getProperties() {
          return m_Properties.toArray(FormObject.EMPTY_ARRAY);
     }

    @Override
    protected void appendInstance(StringBuilder sb, int indent)
    {
        FormObject[] props = getProperties();
        for (int i = 0; i < props.length; i++) {
            FormObject prop = props[i];
            prop.appendInstance(  sb,   indent);
        }
    }

    @Override
    protected void appendBinding(StringBuilder sb, int indent)
    {
        FormObject[] props = getProperties();
          for (int i = 0; i < props.length; i++) {
              FormObject prop = props[i];
              prop.appendBinding(  sb,   indent);
          }
       }

    @Override
    protected void appendInterface(StringBuilder sb, int indent)
    {
        FormObject[] props = getProperties();
         for (int i = 0; i < props.length; i++) {
             FormObject prop = props[i];
             prop.appendInterface(  sb,   indent);
         }
     }
}