package com.lordjoe.formgenerator;

import java.util.*;

/**
 * com.lordjoe.formgenerator.FormType
 *
 * @author Steve Lewis
 * @date Jan 18, 2010
 */
public class FormType
{
    public static FormType[] EMPTY_ARRAY = {};
    public static Class THIS_CLASS = FormType.class;

    private AllowedType m_Type;
    private List<PropertyRestriction> m_Restrictions =
            new ArrayList<PropertyRestriction>();

    public FormType(AllowedType at)
    {
        m_Type = at;
    }

    public AllowedType getType()
    {
        return m_Type;
    }

    public String getXFormType()
    {
        switch (getType()) {
            case Number:
                return "int";
            case Boolean:
                return "string";  // we need to make this a select
            case Date:
                return "date";
            case GeoPoint:
                return "geopoint";
            case String:
                return "string";
            case Select1:
                return "select1";
            case SelectMulti:
                return "select";

        }
        return "string";
    }

    public void setType(AllowedType pType)
    {
        m_Type = pType;
    }

    public void addPropertyRestriction(PropertyRestriction p)
    {
        m_Restrictions.add(p);
    }

    public PropertyRestriction[] getPropertyRestrictions()
    {
        return m_Restrictions.toArray(PropertyRestriction.EMPTY_ARRAY);
    }
}
