package com.lordjoe.formgenerator;

import com.google.api.translate.*;
import com.lordjoe.translation.*;

import java.util.*;

/**
 * com.lordjoe.formgenerator.Translation
 *
 * @author Steve Lewis
 * @date Jan 29, 2010
 */
public class Translation
{
    public static Translation[] EMPTY_ARRAY = {};
    public static Class THIS_CLASS = Translation.class;

    private final String m_Language;
    private final Map<String,TranslationItem>   m_Items = new HashMap<String,TranslationItem>();

    public Translation( LanguageBundle lb)
     {
         String[] keys = lb.getKeys();
          if(keys.length == 0)   {
              lb.load();
              keys = lb.getKeys();
          }
         Language language = lb.getLanguage();
         String s = language.name();
         m_Language = s.toLowerCase();
         for (int i = 0; i < keys.length; i++) {
             String key = keys[i];
             m_Items.put(key,new TranslationItem(key,lb.getProperty(key)));
         }
     }

    public Translation(String pLanguage)
     {
         m_Language = pLanguage;
     }

     public String getLanguage()
    {
        return m_Language;
    }

    public TranslationItem getItem(String id) {
        return m_Items.get(id);
    }

    public void addItem(TranslationItem added)  {
          m_Items.put(added.getID(),added);
    }

    public TranslationItem[] getTranslationItems( )  {
            return m_Items.values().toArray(TranslationItem.EMPTY_ARRAY) ;
      }


}
