package com.lordjoe.measurement;

import com.lordjoe.common.*;
import com.lordjoe.formgenerator.*;

/**
 * com.lordjoe.measurement.IUnit
 *
 * @author Steve Lewis
 * @date Mar 15, 2010
 */
@SimpleType
public interface IUnit<T extends IBaseUnit> extends IPseudoEnum<IUnit<T>> 
{

    public static IUnit[] EMPTY_ARRAY = {};
    public static Class<IUnit> THIS_CLASS = IUnit.class;

    /**
     * unit name - same as toString
     * @return
     */
     public String getName();

    /**
     * true if the units share the same base
     * @param test non-null test
     * @return  as above
     */
    public boolean isCompatable(IUnit<T> test);

    /**
     * alternative known units of this type
     * @return non-null list
     */
    public IUnit<T>[] getOptions();
    /**
     * return the unit which is base
     * @return  non-null base
     */
    public T getBaseUnit();

    /**
     * convert a measurement
     * @param value value in this unit
     * @return  value as a base
     */
    public double convertToBase(double value);

    /**
      * convert a measurement
      * @param value value as base
      * @return  value as this unit
      */
    public double convertFromBase(double value);


}
