package com.lordjoe.measurement;

/**
 * com.lordjoe.measurement.DistanceUnits
 *
 * @author Steve Lewis
 * @date Mar 15, 2010
 */
public class TimeUnits extends BaseUnitOfMeasure<TimeUnits>
{
    public static TimeUnits[] EMPTY_ARRAY = {};
    public static Class<TimeUnits> THIS_CLASS = TimeUnits.class;

    public static TimeUnits INSTANCE = new TimeUnits();

    private TimeUnits()
    {
        super("Sec");

        addOption(new UnitOfMeasure<TimeUnits>("Min", this, 60));
        addOption(new UnitOfMeasure<TimeUnits>("Hour", this, 60 * 60));
        addOption(new UnitOfMeasure<TimeUnits>("Day", this, 24 * 60 * 60));
        addOption(new UnitOfMeasure<TimeUnits>("Week", this, 7 * 24 * 60 * 60));
        addOption(new UnitOfMeasure<TimeUnits>("Month", this, 30 * 24 * 60 * 60));
        addOption(new UnitOfMeasure<TimeUnits>("Year", this, 365 * 24 * 60 * 60));
        addOption(new UnitOfMeasure<TimeUnits>("msec", this, 0.001));
        addOption(new UnitOfMeasure<TimeUnits>("microsec", this, 0.000001));
        addOption(new UnitOfMeasure<TimeUnits>("nanosec", this, 0.000000001));

    }
}