package com.lordjoe.pullparser;

import java.io.*;
import java.util.*;

/**
 * com.lordjoe.pullparser.DocumentHandler
 * 
 * @author Steve Lewis
 * @date Feb 10, 2010
 */
public abstract class DocumentHandler<T> extends AbstractContextHandler<T>
{
    public static DocumentHandler<?>[] EMPTY_ARRAY = {};

    private final Map<String, ElementHandler<T>> m_Handlers = new HashMap<String, ElementHandler<T>>();

    public DocumentHandler()
    {
    }

    public T parse(File f)
    {
        IPullParser<T> pp = PullParserFactory.getPullParser(this);

        return (T) pp.parseXMLDocument(f);
    }

    public T parse(String xml)
    {
        try
        {
            IPullParser<T> pp = PullParserFactory.getPullParser(this);
            return pp.parseXMLDocument(xml);
        } catch (VerifyError e)
        {
            throw e;
        } catch (RuntimeException e)
        {
            throw e;
        }
    }

    public abstract ParseContext<T> buildContext();

    public void addElementHandler(ElementHandler<T> e)
    {
        m_Handlers.put(e.getElementName(), e);
    }

    @Override
    public ElementHandler<T> getElementHandler(String prefix, String localName)
    {
        return m_Handlers.get(buildFullName(prefix, localName));
    }
}
