package com.lordjoe.pullparser;

import java.io.*;

/**
 * com.lordjoe.pullparser.IPullParser
 *
 * @author Steve Lewis
 * @date Feb 28, 2010
 */
public interface IPullParser<T>
{
    public static IPullParser[] EMPTY_ARRAY = {};
    public static Class<IPullParser> THIS_CLASS = IPullParser.class;

    public DocumentHandler<T> getHandler();

    public T parseXMLDocument(File inp);

    /**
     * parse the contents as Stream
     *
     * @param inp
     * @return
     */
    public T parseXMLDocument(String inp);

    /**
     * parse the contents as Stream
     *
     * @param inp
     * @return
     */
    public T parseXMLDocument(InputStream inp);

    /**
       * parse the contents as Reader
       *
       * @param inp
       * @return
       */
      public T parseReader(Reader pInput);
}
