package com.lordjoe.pullparser;

import java.util.*;

/**
 * com.lordjoe.pullparser.ParseContextLevel
 *
 * @author Steve Lewis
 * @date Feb 12, 2010
 */
public class ParseContextLevel<T>
{
    public static ParseContextLevel<?>[] EMPTY_ARRAY = {};
    // public static Class THIS_CLASS = ParseContextLevel.class;


    private final ParseContextLevel<T> m_Parent;
    private final IContextHandler<T> m_Handler;
    private StringBuilder m_Text;
    private List<String> m_Comments;
    private Map<String,Object>  m_Attributes;

    public ParseContextLevel(ParseContextLevel<T> pParent, IContextHandler<T> pHandler)
    {
        m_Parent = pParent;
        m_Handler = pHandler;
    }

    public ParseContextLevel<T> getParent()
    {
        return m_Parent;
    }

    public IContextHandler<T> getHandler()
    {
        return m_Handler;
    }


    public void addText(String text) {
        if(m_Text == null)
             m_Text = new StringBuilder();
         m_Text.append(text);
     }


    public void addComment(String text) {
        if(m_Comments == null)
             m_Comments = new ArrayList<String>();
         m_Comments.add(text);
     }
    public String[] getComments() {
        String[] empty = new String[0];
        if(m_Comments == null)
            return empty;
         return m_Comments.toArray(empty);

    }


     public String getText()
     {
         if(m_Text == null)
             return null;
          return m_Text.toString();
     }

     public Object getValue(String key)
     {
         if(m_Attributes == null)
            return null;
         return m_Attributes.get(key);
     }

    public Object setValue(String key,Object value)
    {
        if(m_Attributes == null)
             m_Attributes = new HashMap<String,Object>();
         return m_Attributes.put(key,value);
    }


}
