package com.lordjoe.translation;

import com.google.api.translate.*;

/**
 * com.lordjoe.translation.LanguageFlag
 *    maps a language into a flag image - largely for UI
 * @author Steve Lewis
 * @date Feb 1, 2010
 */
public enum LanguageFlag
{
    AFRIKAANS(Language.AFRIKAANS,"af"),
	ALBANIAN(Language.ALBANIAN,"albania.png"),
	AMHARIC(Language.AMHARIC,"am"),
	ARABIC(Language.ARABIC,"ar"),
	ARMENIAN(Language.ARMENIAN,"hy"),
	AZERBAIJANI(Language.AZERBAIJANI,"az"),
	BASQUE(Language.BASQUE,"spain_basque.png"),
	BELARUSIAN(Language.BELARUSIAN,"be"),
	BENGALI(Language.BENGALI,"bn"),
	BIHARI(Language.BIHARI,"bh"),
	BULGARIAN(Language.BULGARIAN,"bg"),
	BURMESE(Language.BURMESE,"my"),
	CATALAN(Language.CATALAN,"ca"),
	CHEROKEE(Language.CHEROKEE,"chr"),
	CHINESE(Language.CHINESE,"china.png"),
	CHINESE_SIMPLIFIED(Language.CHINESE_SIMPLIFIED,"china.pngN"),
	CHINESE_TRADITIONAL(Language.CHINESE_TRADITIONAL,"china.png"),
	CROATIAN(Language.CROATIAN,"croatia.png"),
	CZECH(Language.CZECH,"czech_republic.png"),
	DANISH(Language.DANISH,"denmark.png"),
	DHIVEHI(Language.DHIVEHI,"dv"),
	DUTCH(Language.DUTCH,"netherlands.png"),
	ENGLISH(Language.ENGLISH,"united_states.png"),
	ESPERANTO(Language.ESPERANTO,"esperanto.png"),
	ESTONIAN(Language.ESTONIAN,"estonia.png"),
	FILIPINO(Language.FILIPINO,"tl"),
	FINNISH(Language.FINNISH,"finland.png"),
	FRENCH(Language.FRENCH,"france.png"),
	GALICIAN(Language.GALICIAN,"gl"),
	GEORGIAN(Language.GEORGIAN,"ka"),
	GERMAN(Language.GERMAN,"de"),
	GREEK(Language.GREEK,"greece.png"),
	GUARANI(Language.GUARANI,"gn"),
	GUJARATI(Language.GUJARATI,"gu"),
	HEBREW(Language.HEBREW,"isreal.png"),
	HINDI(Language.HINDI,"hi"),
	HUNGARIAN(Language.HUNGARIAN,"hungary.png"),
	ICELANDIC(Language.ICELANDIC,"iceland.png"),
	INDONESIAN(Language.INDONESIAN,"indonesia.png"),
	INUKTITUT(Language.INUKTITUT,"iu"),
	IRISH(Language.IRISH,"ireland.png"),
	ITALIAN(Language.ITALIAN,"italy.png"),
	JAPANESE(Language.JAPANESE,"japan.png"),
	KANNADA(Language.KANNADA,"kn"),
	KAZAKH(Language.KAZAKH,"kk"),
	KHMER(Language.KHMER,"km"),
	KOREAN(Language.KOREAN,"ko"),
	KURDISH(Language.KURDISH,"ku"),
	KYRGYZ(Language.KYRGYZ,"ky"),
	LAOTHIAN(Language.LAOTHIAN,"lo"),
	LATVIAN(Language.LATVIAN,"latvia.png"),
	LITHUANIAN(Language.LITHUANIAN,"lt"),
	MACEDONIAN(Language.MACEDONIAN,"mk"),
	MALAY(Language.MALAY,"ms"),
	MALAYALAM(Language.MALAYALAM,"ml"),
	MALTESE(Language.MALTESE,"mt"),
	MARATHI(Language.MARATHI,"mr"),
	MONGOLIAN(Language.MONGOLIAN,"mongolia.png"),
	NEPALI(Language.NEPALI,"nepal.png"),
	NORWEGIAN(Language.NORWEGIAN,"norway.png"),
	ORIYA(Language.ORIYA,"or"),
	PASHTO(Language.PASHTO,"ps"),
	PERSIAN(Language.PERSIAN,"iran.png"),
	POLISH(Language.POLISH,"poland.png"),
	PORTUGUESE(Language.PORTUGUESE,"portugal.png"),
	PUNJABI(Language.PUNJABI,"pa"),
	ROMANIAN(Language.ROMANIAN,"romania.png"),
	RUSSIAN(Language.RUSSIAN,"russia.png"),
	SANSKRIT(Language.SANSKRIT,"sa"),
	SERBIAN(Language.SERBIAN,"serbia.png"),
	SINDHI(Language.SINDHI,"sd"),
	SINHALESE(Language.SINHALESE,"si"),
	SLOVAK(Language.SLOVAK,"slovakia.png"),
	SLOVENIAN(Language.SLOVENIAN,"slovenia.png"),
	SPANISH(Language.SPANISH,"spain.png"),
	SWAHILI(Language.SWAHILI,"kenya.png"),
	SWEDISH(Language.SWEDISH,"sweden.png"),
	TAJIK(Language.TAJIK,"tg"),
	TAMIL(Language.TAMIL,"ta"),
	TAGALOG(Language.TAGALOG,"tl"),
	TELUGU(Language.TELUGU,"te"),
	THAI(Language.THAI,"thailand.png"),
	TIBETAN(Language.TIBETAN,"tibet.png"),
	TURKISH(Language.TURKISH,"turkey.png"),
	UKRANIAN(Language.UKRANIAN,"ukrainia.png"),
	URDU(Language.URDU,"ur"),
	UZBEK(Language.UZBEK,"uz"),
	UIGHUR(Language.UIGHUR,"ug"),
	VIETNAMESE(Language.VIETNAMESE,"vietnam.png"),
	WELSH(Language.WELSH,"cy"),
	YIDDISH(Language.YIDDISH,"yi");

    private final Language m_Language;
    private final String m_Flag;

    LanguageFlag(Language pLanguage, String pFlag)
    {
        m_Language = pLanguage;
        m_Flag = pFlag;
    }

    public Language getLanguage()
    {
        return m_Language;
    }

    public String getFlag()
    {
        return m_Flag;
    }
}
