package com.lordjoe.translation;

/**
 * com.lordjoe.translation.TranslationEntry
 *
 * @author Steve Lewis
 * @date Feb 2, 2010
 */
public class TranslationEntry
{
    public static TranslationEntry[] EMPTY_ARRAY = {};
    public static Class THIS_CLASS = TranslationEntry.class;

    private final String m_Key;
    private String m_Value;
    private boolean m_HandEdited;

    public TranslationEntry(String pKey)
      {
          m_Key = pKey;
      }
    public TranslationEntry(String pKey,String value)
      {
          this(pKey);
          setValue(value);
      }

    public String getKey()
    {
        return m_Key;
    }

    public String getValue()
    {
        return m_Value;
    }

    public void setValue(String pValue)
    {
        m_Value = pValue;
    }

    public boolean isHandEdited()
    {
        return m_HandEdited;
    }

    public void setHandEdited(boolean pHandEdited)
    {
        m_HandEdited = pHandEdited;
    }

    @Override
     public String toString()
     {
         return getKey() + ":" + getValue();

     }

}
