package com.lordjoe.translation;

import com.lordjoe.pullparser.*;

/**
 * com.lordjoe.translation.TranslationEntryHandler
 *
 * @author Steve Lewis
 * @date Feb 10, 2010
 */
public class TranslationEntryHandler  extends ElementHandler<LanguageBundle>
{
    public static TranslationEntryHandler[] EMPTY_ARRAY = {};
    public static Class THIS_CLASS = TranslationEntryHandler.class;

    private String m_Name;

    public TranslationEntryHandler()
    {
        super("string");
        buildHandlers();
    }

    protected void buildHandlers()
    {
    //   addAttributeHandler(new NameHandler());
    }
    public String getName()
    {
        return m_Name;
    }

    public void setName(String pName)
    {
        m_Name = pName;
    }


    @Override
    public void onClose(ParseContext<LanguageBundle> ctx)
    {
        LanguageBundle languageBundle = ctx.getActiveDocument();
        String name = getName();
        String value = ctx.getText();
        languageBundle.addTranslationEntry(new TranslationEntry(name, value));
        setName(null);
    }


}
