package com.lordjoe.translation;

import com.google.api.translate.*;

/**
 * com.lordjoe.translation.Translator
 *
 * @author Steve Lewis
 * @date Jan 31, 2010
 */
public class Translator
{
    public static Translator[] EMPTY_ARRAY = {};
    public static Class THIS_CLASS = Translator.class;

    public static final String DEFAULT_WEB_SITE = "http://code.google.com/p/i18n-translator/";
    public static final Language DEFAULT_LANGUAGE = Language.ENGLISH;

    private static String gWebSite = DEFAULT_WEB_SITE;
    private static Language gDefaultLanguage= DEFAULT_LANGUAGE;

    public static void setWebSite(String pWebSite)
    {
        gWebSite = pWebSite;
    }

    public static Language getDefaultLanguage()
    {
        return gDefaultLanguage;
    }

    public static void setDefaultLanguage(Language pDefaultLanguage)
    {
        gDefaultLanguage = pDefaultLanguage;
    }

    private static Translator gInstance;

    public static synchronized Translator getTranslator()
    {
        if (gInstance == null)
            gInstance = new Translator();
        return gInstance;
    }

    private Language m_BaseLanguage = getDefaultLanguage();
    public Translator()
    {
        Translate.setHttpReferrer(gWebSite);
         System.setProperty("http.proxyHost", "proxy");
        System.setProperty("http.proxyPort", "8080");
    }

    public Language getBaseLanguage()
    {
        return m_BaseLanguage;
    }

    public void setBaseLanguage(Language pBaseLanguage)
    {
        m_BaseLanguage = pBaseLanguage;
    }

    /**
       * @param input
       * @param target
       * @return
       */
      public String translateTo(String input, Language to)
      {
          return translate(input,getBaseLanguage(), to);
      }
    /**
       * @param input
       * @param target
       * @return
       */
      public String[] translateTo(String[] input, Language to)
      {
          return translate(input, getBaseLanguage(), to);
      }

    /**
     * @param input
     * @param target
     * @return
     */
    public String translateFrom(String input, Language from)
    {
        return translate(input, from, getBaseLanguage());
    }
    /**
     * @param input
     * @param target
     * @return
     */
    public String[] translateFrom(String[] input, Language from)
    {
        return translate(input, from, getBaseLanguage());
    }


    public String translate(String input, Language from, Language to)
    {
        try {
            return Translate.execute(input, from, to);
        }
        catch (Exception e) {
            throw new IllegalStateException(e);
        }
    }

    public String[] translate(String[] input, Language from, Language to)
    {
        try {
            return Translate.execute(input, from, to);
        }
        catch (Exception e) {
            throw new IllegalStateException(e);
        }
    }


}
