package forms;

import java.util.*;

import com.google.api.translate.*;
import com.lordjoe.formgenerator.*;

/**
 * forms.SeajugSurvey
 *
 * @author Steve Lewis
 * @date Apr 11, 2010
 */
@PropertyPrefix(Prefix = "m_")
@SurveyName(Name = "Seajug Survey")
@SupportedLanguages(Languages = { Language.ENGLISH,Language.GERMAN,Language.FRENCH})
public class SeajugSurvey
{
    @Required
    @MaxLength(Max = 64)
    String m_Name;
    @Required
    Sex m_Sex;
    boolean m_Member;
    Language m_FavoriteLanguage;

    @RelevantIf(Expression = "selected(/Seajug_Survey/FavoriteLanguage, \'Java\')")
    JavaQuestions  m_QuestionsOnJava;

    @RelevantIf(Expression ="selected(/Seajug_Survey/FavoriteLanguage, \'CSharp\')")
    CSharpQuestions m_QuestionsOnCSharp;

    @Question(Id = "Do you develop Web Applications")
    boolean m_WebApplications;
    @RelevantIf(Expression = "/Seajug_Survey/WebApplications=true")
    WebQuestions m_WebQuestions;

    @Question(Id = "Do you develop Desktop Applications")
    boolean m_DesktopApplications;
    @RelevantIf(Expression = "/Seajug_Survey/DesktopApplications=true")
    DesktopQuestions m_DesktopQuestions;

    @Question(Id = "Do you develop Mobile")
    boolean m_MobileApplications;
     @RelevantIf(Expression = "MobileApplications=true")
    MobileQuestions m_MobileQuestions;

    IDE m_FavoriteIDE;

    private List<CodeProject> m_Projects; 


    private class JavaQuestions
    {
        @MaxValue(Max = 15)
        int YearsUsingJava;
    }

    private class CSharpQuestions
    {
        @Question(Id = "You poor sod Are You Forced to do it")
        boolean Forced;
    }

    /*  ========================================
    *   Enumerations
    *  =========================================
        */
    public enum Sex
    {
        Male, Female
    }

    public enum IDE
    {
        Eclipse, IntelliJ, NetBeans, Other
    }

    public enum Language
    {
        Java, CSharp, Perl, Scala
    }

    /*  ========================================
      *   Innerclasses Mapped tp question groups
      *  =========================================
          */

    public class WebQuestions
    {

        boolean JFC;
    }

    public class DesktopQuestions
     {

         boolean Swing;
     }
    public class MobileQuestions
      {

          boolean Swing;
      }
    public class CodeProject
      {
          String projectName;
          String companyName;
        }


}
